
## COMPUTATION OF ONE BAYES FACTOR FOR THE TEST DELTA == 0 ##

library(Directional)
source("fun_G_0abs.R")


s <- 1e4

# 1. insert the value of the parameters m1, k1 and k2

s3 <- readline(prompt = "insert the  value of m1: ")
m1 <- eval(parse(text = s3))

s4 <- readline(prompt = "insert the  value of k1: ")
k1 <- eval(parse(text = s4))

s5 <- readline(prompt = "insert the  value of k2: ")
k2 <- eval(parse(text = s5))

# 2. insert real data theta of size n

s6 <- readline(prompt = "insert the data as a vector of length n: ")
theta <- eval(parse(text = s6))

n <- length(theta)

# NOMINATOR #

f <- function(x,y) (1/(2*pi*G0_abs(y,k1,k2)))*exp(k1*cos(x-m1)+k2*cos(2*(x-(m1-y)%%pi)))

ff <- rep(0,n)

  for (i in 1:n) {
    
    ff[i] <- f(theta[i],0)
  }

N <- prod(ff)


###############################################

# DENOMINATOR #


# test for delta #

epsilon <- 0.05

# 3. fix the hyperparameters nu and tau for the prior or delta

s1 <- readline(prompt = "insert the  value of tau: ")
tau <- eval(parse(text = s1))

s2 <-  readline(prompt = "insert the  value of nu: ")
nu <- eval(parse(text = s2))

# 4.generate a sample of size s of prior values for delta: these are used to compute the integral via MonteCarlo method

delta <- rvonmises(s, 2*nu,tau)
delta <- delta/2

index <- (delta > epsilon/2 & delta < pi-epsilon/2)

delta <- delta[index]

tmp <- rep(0,n)
M <- rep(0,length(delta))

  for (k in 1:length(delta)) {
    for (j in 1:n) {
      tmp[j] <- f(theta[j],delta[k])
    }
    M[k] <- prod(tmp)
  }
  D <- sum(M)/s

# BAYES FACTOR #

BF <- N/D

