## COMPUTATION OF ONE BAYES FACTOR FOR THE TEST KAPPA2 = 0 ##

library(Directional)
source("fun_G_0abs.R")


s <- 1e4

# 1. insert the value of the parameters m1, k1 and m2

s3 <- readline(prompt = "insert the  value of m1: ")
m1 <- eval(parse(text = s3))

s4 <- readline(prompt = "insert the  value of k1: ")
k1 <- eval(parse(text = s4))

s5 <- readline(prompt = "insert the  value of m2: ")
m2 <- eval(parse(text = s5))

# 2. insert real data theta of size n

s6 <- readline(prompt = "insert the data as a vector of length n: ")
theta <- eval(parse(text = s6))

n <- length(theta)

# NOMINATOR #

d <- (m1 - m2)%%pi


f <- function(x,y) (1/(2*pi*G0_abs(d,k1,y)))*exp(k1*cos(x-m1)+y*cos(2*(x-m2))) # likelihood #

ff <- rep(0,n)


  for (i in 1:n) {
    
    ff[i] <- f(theta[i],0) #vonmises #
  }

  N <- prod(ff)


###############################################

# DENOMINATOR #


epsilon <- 0.05

s7 <- readline(prompt = "insert the  value of k_2: ")
k_2 <- eval(parse(text = s7))
kappa2 <- runif(s,0,k_2)

index <- (kappa2 > epsilon)

kappa2 <- kappa2[index]

# PARALLELIZATION

# Simulation parameters
library(doParallel)
n.clust <- 16

# Creating clusters
cl <- makeCluster(n.clust)
registerDoParallel(cl)


#M<-array(NA,dim=c(r,n,length(delta)))
tmp <- rep(0,n)
M <- rep(0,length(kappa2))

  for (k in 1:length(kappa2)) {
    for (j in 1:n) {
      tmp[j] <- f(theta[j],kappa2[k])
    }
    M[k] <- prod(tmp)
  }
 D <-  sum(M)/s

# Bayes Factor #

BF <- N/D