## Function to simulate from a mixture of two vonMises distributions ##

mixture <- function(n,xi,nu1,nu2,tau){
  library(Directional)
  d <- rep(0,n)
  delta <- rep(0,n)
    for (i in 1:n) {
    U <- runif(1,0,1)
    if (U<=xi) {d[i] <- rvonmises(1,2*nu1,tau)
                delta[i] <- d[i]/2}
    else {d[i] <- rvonmises(1,2*nu2,tau)
                delta[i] <- d[i]/2}
    }
    
    return(delta)
  
}